﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using APlan.ViewModel;
using System.Collections.ObjectModel;

namespace APlan.Client
{
    /// <summary>
    /// Interaction logic for HeatMap.xaml
    /// </summary>
    public partial class HeatMap : UserControl, INotifyPropertyChanged
    {

        private ObservableCollection<APlan.Service.CustIBaseView> _selectedCust;
        int _numberSelected;
        public ObservableCollection<APlan.Service.CustIBaseView> SelectedCust
        {
            set
            {
                _selectedCust = value;
                OnPropertyChanged("SelectedCust");
            }
            get
            {
                return _selectedCust;
            }
        }

        public int NumberSelected
        {
            set
            {
                if (_numberSelected != value)
                {
                    _numberSelected = value;
                    OnPropertyChanged("NumberSelected");
                }
            }
            get
            {
                return _numberSelected;
            }
        }

        public HeatMap()
        {
            InitializeComponent();
            StartDate.SelectedDate = System.DateTime.Now;
            //EndDate.SelectedDate = System.DateTime.Now;
        }
        
        private void HeatList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int sum = 0;
            SelectedCust = new ObservableCollection<APlan.Service.CustIBaseView>();
            foreach (HeatMapViewModel h in HeatList.SelectedItems)
            {
                sum += h.NumberOfCustomers;
                HeatMapViewModel t = ViewModelLocator.MainStatic.UpdateOpenCustHeatMap(h);
                foreach (APlan.Service.CustIBaseView c in t.OpenCustomers)
                {
                    SelectedCust.Add(c);
                }
            }
            NumberSelected = sum;
            /*
            Nullable<DateTime> newenddate = EndDate.SelectedDate.Value.AddDays(sum / 25);
            EndDate.SelectedDate = newenddate;
             * */
        }

        #region INotifyPropertyChanged Members

        /// <summary>
        /// Raises the 'PropertyChanged' event when the value of a property of the data model has changed.
        /// </summary>
        private void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private void StartDate_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        {
            ViewModelLocator.MainStatic.RouteplanStartDate = (DateTime) StartDate.SelectedDate;
        }
        /*
        private void EndDate_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        {
            ViewModelLocator.MainStatic.RouteplanEndDate = (DateTime)EndDate.SelectedDate;
        }
         * */
    }
}
