﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using System.Threading;
using APlan.Service;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using System.Windows.Data;
namespace APlan.ViewModel
{
    /// <summary>
    /// Represents a customer with the corresponding IBase
    /// </summary>
    public class CustIBaseViewModel : ViewModelBase
    {
                
        public CustIBaseView Model
        {
            get;
            set;
        }
        /// <summary>
        /// the assignments of the customer
        /// </summary>
        public ObservableCollection<AssignmentViewModel> AssignmentViewmodels
        {
            get;
            set;
        }
        /// <summary>
        /// the assignments as CollectionView
        /// </summary>
        public ListCollectionView AssignmentCollectionView
        {
            get;
            set;
        }
        /// <summary>
        /// return the adress of the customer
        /// </summary>
        public string CustomerAdress
        {
            get
            {
                return Model.Street + " " + Model.HNr + ", " + Model.Post_code + " " + Model.City;
            }
            private set
            {
            }
        }
        /// <summary>
        /// return the adress of the IBase
        /// </summary>
        public string IBaseAdress
        {
            get
            {
                return Model.IBaseStreet + " " + Model.IBaseHNr + ", " + Model.IBasePostCode + " " + Model.IBaseCity;
            }
        }
        public CustIBaseViewModel(CustIBaseView civ)
        {            
            Model = civ;
        }
        public CustIBaseView GetCustIBaseView()
        {
            
            return Model;
        }
        #region INotifyPropertyChanged Members
        /*
        event PropertyChangedEventHandler INotifyPropertyChanged.PropertyChanged
        {
            add { throw new NotImplementedException(); }
            remove { throw new NotImplementedException(); }
        }
        */
        #endregion

    }
}
