﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using APlan.Service;
using System.ComponentModel;
using System.Windows.Media;
using System.ServiceModel;
using System.Collections.ObjectModel;
using APlan;
using GalaSoft.MvvmLight;

namespace APlan.ViewModel
{
    /// <summary>
    /// ViewModel for messages
    /// </summary>
    public class MessageViewModel : ViewModelBase 
    {
        private string _message;
        private DateTime _postingDate, _validTo;

        public Guid ID;
        public String Message
        {
            get
            {
                return _message;
            }
            set
            {
                if (_message != value)
                {
                    _message = value;
                    RaisePropertyChanged("Message");   
                }
            }
        }

        public DateTime PostingDate
        {
            get
            {
                return _postingDate;
            }
            set
            {
                if (_postingDate != value)
                {
                    _postingDate = value;
                    RaisePropertyChanged("PostingDate");
                }
            }
        }

        public String PostingDateString
        {
            get
            {
                return _postingDate.ToShortDateString();
            }
        }
        public DateTime ValidTo
        {
            get
            {
                return _validTo;
            }
            set
            {
                if (_validTo != value)
                {
                    _validTo = value;
                    RaisePropertyChanged("ValidTo");
                }
            }
        }
        
    }
}
