﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using APlan.Service;
using System.Windows.Media;
using System.Globalization;

namespace APlan.ViewModel
{
    public class HeatMapViewModel
    {
        private DateTime _from;
        public DateTime From 
        { 
            set
            {
                _from = value;
                if (_from.DayOfWeek != DayOfWeek.Monday)
                {
                    int dow = (int)_from.DayOfWeek;
                    if (dow == 0)
                        dow = 7;
                    DateTime help = _from.AddDays(dow * (-1) + 1);
                    if (help.Year != _from.Year)
                        _from = new DateTime(_from.Year, 1, 1);
                    else
                        _from = new DateTime(help.Year, help.Month, help.Day);
                }
            }
            get
            {
                return _from;
            }
        }
        public DateTime To
        {
            get
            {
                int dowfrom = (int)_from.DayOfWeek;
                return _from.AddDays(8 - dowfrom);
            }
        }
        public int WeekNr 
        {
            get
            {
                CultureInfo ci = new CultureInfo("en-US");
                Calendar ca = ci.Calendar;
                CalendarWeekRule cwr = ci.DateTimeFormat.CalendarWeekRule;
                DayOfWeek firstdow = ci.DateTimeFormat.FirstDayOfWeek;
                int weeknr = ca.GetWeekOfYear(From, cwr, firstdow);
                return weeknr;
            }
        }
        public CustIBaseView[] OpenCustomers { get; set; }
        public int NumberOfCustomers { get; set; }
        public Brush Color
        {
            get
            {
                if (NumberOfCustomers == 0)
                    return new SolidColorBrush(Colors.White);
                else
                {
                    SolidColorBrush br = new SolidColorBrush();
                    
                    Color col = new Color();
                    col.A = 255;
                    col.R = 255;
                    int g = 255 - NumberOfCustomers;
                    col.G = (byte)g;
                    return new SolidColorBrush(col);
                }
            }
        }

        public String DateText
        {
            get
            {
                return From.ToShortDateString() + " to " + To.ToShortDateString();
            }

        }
        public String CustomerText
        {
            get
            {
                return "Customers " + NumberOfCustomers;
            }
        }
    }
}
